<?php

// Handle running this file by using SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

global $modSettings;
// Any friendly reminders telling us if SimplePortal has already been installed?
if(!empty($modSettings['SimplePortal_version']) && $modSettings['SimplePortal_version'] != '2.1' && !empty($modSettings['SimplePortal_last_smf_version']))
{
	// At the moment there are only two versions that have those variables - 2.0.5/2.0.6. Only one Database change is required for this upgrade,
	$request = db_query("SHOW COLUMNS FROM {$db_prefix}sp_blocks", __FILE__, __LINE__);
	
	$installed = false;
	while($row = mysql_fetch_assoc($request) ) 
	{
		$installed = $row['Field'] == 'display';
		if($installed)
			break;
	}
	mysql_free_result($request);
	
	if(!$installed)
		db_query("ALTER TABLE {$db_prefix}sp_blocks ADD display text NOT NULL", __FILE__, __LINE__);
}
// Otherwise, lets do things the long way.
else 
{	
	// Firstly, add the SimplePortal tables if they don't already exist.
	// Articles Table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_articles (
	  ID_ARTICLE int(10) NOT NULL auto_increment,
	  ID_CATEGORY int(10) NOT NULL default 0,
	  ID_MESSAGE int(10) NOT NULL default 0,
	  approved tinyint(2) NOT NULL default 0,
	  PRIMARY KEY  (ID_ARTICLE)
	)", __FILE__, __LINE__);

	// Blocks Table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_blocks (
	  ID_BLOCK int(10) unsigned NOT NULL auto_increment,
	  label tinytext NOT NULL,
	  type text NOT NULL,
	  content text NOT NULL,
	  parameters tinytext NOT NULL,
	  col tinyint(4) unsigned NOT NULL default 0,
	  row tinyint(4) unsigned NOT NULL default 0,
	  state tinyint(4) NOT NULL default 1,
	  allowed_groups text NOT NULL,
	  force_view tinyint(2) unsigned NOT NULL default 0,
	  permission_type tinyint(2) unsigned NOT NULL default 0,
	  display text NOT NULL,
	  PRIMARY KEY  (ID_BLOCK)
	)", __FILE__, __LINE__);

	// Categories Table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_categories (
	  ID_CATEGORY int(10) unsigned NOT NULL auto_increment,
	  name tinytext NOT NULL,
	  picture tinytext NOT NULL,
	  articles tinyint(4) NOT NULL default 0,
	  publish tinyint(1) NOT NULL default 0,
	  PRIMARY KEY  (ID_CATEGORY)
	)", __FILE__, __LINE__);

	// Functions Table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_functions (
	  ID_FUNCTION tinyint(4) NOT NULL auto_increment,
	  name tinytext NOT NULL,
	  parameter tinyint(4) NOT NULL default 0,
	  PRIMARY KEY  (ID_FUNCTION)
	)", __FILE__, __LINE__);
	
	// Now, lets make sure that any old versions are updated.
	/*
	This Change work even if it changed, it should not create an error because nothing will happen if it allready done.
	2.0.0 -> 2.0.3
	*/
	db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_ARTICLE 
		ID_ARTICLE INT( 10 ) NOT NULL AUTO_INCREMENT", __FILE__, __LINE__);

	db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_CATEGORY 
		ID_CATEGORY INT( 10 ) DEFAULT 0 NOT NULL", __FILE__, __LINE__);

	db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_MESSAGE 
		ID_MESSAGE INT( 10 ) DEFAULT 0 NOT NULL", __FILE__, __LINE__);

	/*This is the array for alter Tables... i use this as my advance installer so i can made some changes quicker *g*
		Table without db_prefix
			array('table', 'rowname', 'rowsetting', 'update value');
		
		This Check if the row exists, if not than create it :), easy for update handling ;)
	*/

	$sql_adds = array(
		//2.0.3 -> 2.0.4
		array("sp_blocks", "allowed_groups", "text not null"),
		array("sp_blocks", "force_view", "TINYINT(2) unsigned DEFAULT '0' NOT NULL"),
		//2.0.4 -> 2.0.5
		array("sp_blocks", "permission_type", "TINYINT(2) unsigned DEFAULT '0' NOT NULL"),
		// 2.0.x -> 2.1.0.
		array("sp_blocks", "display", "text NOT NULL"),
	);
	
	foreach($sql_adds as $rowinfo) {
		
		$table = $rowinfo['0'];
		$rowname = $rowinfo['1'];
		$rowsetting = $rowinfo['2'];	

		//Mistake made... hmmm what should i do? XD Tell him that something not correct!
		if(empty($rowname) || empty($rowsetting)) {
			echo "SQL SMF INSTALLER: Error... rowname or rowsetting not set!";
			die();
		}
		
		//Load the rows ;)
		$request = db_query("SHOW COLUMNS FROM {$db_prefix}{$table}", __FILE__, __LINE__);
		
		$installed = false;
		
		while($row = mysql_fetch_assoc($request) ) {
			$installed = $row['Field'] == $rowname;
			if($installed)
				break;
		}
		
		mysql_free_result($request);
		
		//Not Installed Intall it ;)
		if(!$installed) {
			db_query("ALTER TABLE {$db_prefix}{$table} ADD $rowname $rowsetting", __FILE__, __LINE__);
			
			//I need to change values? Because it's new installed :)
			if(isset($rowinfo['3'])) {
				db_query("
					UPDATE {$db_prefix}{$table}
					SET $rowname = $rowinfo[3]", __FILE__, __LINE__);
			}
		}
	}

	//This is an special update, for older Versions than 2.0.4
	$request = db_query("
		SELECT ID_GROUP, minPosts
		FROM {$db_prefix}membergroups", __FILE__, __LINE__);
	$member_groups = array('posts' => array(), 'standard' => array());
	while ($row = mysql_fetch_assoc($request)) {
		$member_groups[$row['minPosts'] == '-1' ? 'posts' : 'standard'][] = $row['ID_GROUP'];
	}
	mysql_free_result($request);

	$member_groups['standard'][] = 0;
	$member_groups['standard'][] = -1;

	$allowed_groups_standard = implode(',', $member_groups['standard']);
	$allowed_groups_new = $allowed_groups_standard . implode(',', $member_groups['posts']);

	//This is an Special update ;D
	db_query("
		UPDATE {$db_prefix}sp_blocks
		SET allowed_groups = '$allowed_groups_new', permission_type = 2
		WHERE allowed_groups = '$allowed_groups_standard'
			OR allowed_groups = ''", __FILE__, __LINE__);
}

// Function Settings
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (18, 'sp_php', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (17, 'sp_html', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (16, 'sp_smfGallery', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (15, 'sp_smfArcade', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (14, 'sp_smfShop', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (13, 'sp_news', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (12, 'sp_boardNews', 5)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (11, 'sp_recentTopics', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (10, 'sp_recentPosts', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (9, 'sp_topTopics', 2)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (8, 'sp_topBoards', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (7, 'sp_topPoster', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (6, 'sp_quickSearch', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (5, 'sp_boardStats', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (4, 'sp_showPoll', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (3, 'sp_whosOnline', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (2, 'sp_latestMember', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (1, 'sp_userInfo', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (19, 'sp_bbc', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (20, 'sp_attachmentImage', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (21, 'sp_attachmentRecent', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (22, 'sp_mgallery', 2)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (23, 'sp_recent', 2)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (24, 'sp_calendarInformation', 4)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (25, 'sp_rssFeed', 1)", __FILE__, __LINE__);

$defaults = array(
	'portalactive' => 1,
	'sp_disableForumRedirect' => 1,
	'showleft' => 1,
	'showright' => 1,
	'leftwidth' => 200,
	'rightwidth' => 200,
	'sp_enableIntegration' => 1,
	'sp_adminIntegrationHide' => 1,
);

$updates = array(
	'SimplePortal_version' => '2.1',
	'SimplePortal_last_smf_version' => '1.1',
);

foreach ($defaults as $index => $value)
	if (!isset($modSettings[$index]))
		$updates[$index] = $value;

updateSettings($updates);

// Show a confirmation message, if an upgrade through SSI.php was successful.
if(SMF == 'SSI')
	echo 'Database Upgrade Complete!';

?>