<?php

// Handle running this file by using SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF')) 
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Make sure that we have the package database functions.
if (!array_key_exists('db_add_column', $smcFunc))
	db_extend('packages');
	
// Set up the columns for the Articles Table
$columns = array(
	array(
		'name' => 'id_article',
		'type' => 'int',
		'size' => '10',
		'auto' => true,
	),
	array(
		'name' => 'id_category',
		'type' => 'int',
		'size' => '10',
		'default' => 0,
	),
	array(
		'name' => 'id_message',
		'type' => 'int',
		'size' => '10',
		'default' => 0,
	),
	array(
		'name' => 'approved',
		'type' => 'tinyint',
		'size' => '2',
	),
);

// Set up the index for the Articles Table
$indexes = array(
	array(
		'type' => 'primary',
		'columns' => array('id_article'),
	),
);

// Finally create the Articles table.
$smcFunc['db_create_table']('sp_articles', $columns, $indexes, array(), 'update_remove');

// Set up the columns for the Blocks Table
$columns = array(
	array(
		'name' => 'id_block',
		'type' => 'int',
		'size' => '10',
		'auto' => true,
	),
	array(
		'name' => 'label',
		'type' => 'tinytext',
	),
	array(
		'name' => 'type',
		'type' => 'text',
	),
	array(
		'name' => 'content',
		'type' => 'text',
	),
	array(
		'name' => 'parameters',
		'type' => 'tinytext',
	),
	array(
		'name' => 'col',
		'type' => 'tinyint',
		'size' => '4',
		'default' => 0,
	),
	array(
		'name' => 'row',
		'type' => 'tinyint',
		'size' => '4',
		'default' => 0,
	),
	array(
		'name' => 'state',
		'type' => 'tinyint',
		'size' => '4',
		'default' => 1,
	),
	array(
		'name' => 'allowed_groups',
		'type' => 'text',
		'size' => '4',
	),
	array(
		'name' => 'force_view',
		'type' => 'tinyint',
		'size' => '2',
		'default' => 0,
	),
	array(
		'name' => 'permission_type',
		'type' => 'tinyint',
		'size' => '2',
		'default' => 0,
	),
	array(
		'name' => 'display',
		'type' => 'text',
	),
);

// Set up the index for the Blocks Table
$indexes = array(
	array(
		'type' => 'primary',
		'columns' => array('id_block'),
	),
);

// Finally create the Blocks table.
$smcFunc['db_create_table']('sp_blocks', $columns, $indexes, array(), 'update_remove');

// Set up the columns for the Categories Table
$columns = array(
	array(
		'name' => 'id_category',
		'type' => 'int',
		'size' => '10',
		'auto' => true,
	),
	array(
		'name' => 'name',
		'type' => 'tinytext',
	),
	array(
		'name' => 'picture',
		'type' => 'tinytext',
	),
	array(
		'name' => 'articles',
		'type' => 'tinyint',
		'size' => '4',
		'default' => 0,
	),
	array(
		'name' => 'publish',
		'type' => 'tinyint',
		'size' => '1',
		'default' => 0,
	),
);

// Set up the index for the Categories Table
$indexes = array(
	array(
		'type' => 'primary',
		'columns' => array('id_category'),
	),
);

// Finally create the Categories table.
$smcFunc['db_create_table']('sp_categories', $columns, $indexes, array(), 'update_remove');

// Set up the columns for the Functions Table
$columns = array(
	array(
		'name' => 'id_function',
		'type' => 'tinyint',
		'size' => '4',
		'auto' => true,
	),
	array(
		'name' => 'name',
		'type' => 'tinytext',
	),
	array(
		'name' => 'parameter',
		'type' => 'tinyint',
		'size' => '4',
		'default' => 0,
	),
);

// Set up the index for the Functions Table
$indexes = array(
	array(
		'type' => 'primary',
		'columns' => array('id_function'),
	),
);

// Finally create the Functions table.
$smcFunc['db_create_table']('sp_functions', $columns, $indexes, array(), 'update_remove');

// Add a whole lot of Function Settings.
$smcFunc['db_insert']('ignore', '{db_prefix}sp_functions',
	array('id_function' => 'int', 'name' => 'string', 'parameter' => 'int'),
	array(
		array(18, 'sp_php', 0),
		array(17, 'sp_html', 0),
		array(16, 'sp_smfGallery', 1),
		array(13, 'sp_news', 0),
		array(12, 'sp_boardNews', 5),
		array(11, 'sp_recentTopics', 1),
		array(10, 'sp_recentPosts', 1),
		array(9, 'sp_topTopics', 2),
		array(8, 'sp_topBoards', 1),
		array(7, 'sp_topPoster', 1),
		array(6, 'sp_quickSearch', 0),
		array(5, 'sp_boardStats', 0),
		array(4, 'sp_showPoll', 1),
		array(3, 'sp_whosOnline', 0),
		array(2, 'sp_latestMember', 0),
		array(1, 'sp_userInfo', 0),
		array(19, 'sp_bbc', 0),
		array(20, 'sp_attachmentImage', 1),
		array(21, 'sp_attachmentRecent', 1),
		array(22, 'sp_mgallery', 2),
		array(23, 'sp_recent', 2),
		array(24, 'sp_calendarInformation', 4),
		array(25, 'sp_rssFeed', 1),
	),
	array('id_function')
);

// Let's setup some standard settings for the width if not exists
global $modSettings;

$defaults = array(
	'portalactive' => 1,
	'sp_disableForumRedirect' => 1,
	'showleft' => 1,
	'showright' => 1,
	'leftwidth' => 200,
	'rightwidth' => 200,
	'sp_enableIntegration' => 1,
	'sp_adminIntegrationHide' => 1,
);

$updates = array(
	'SimplePortal_version' => '2.1',
	'SimplePortal_last_smf_version' => '2',
);

foreach ($defaults as $index => $value)
	if (!isset($modSettings[$index]))
		$updates[$index] = $value;

updateSettings($updates);

// Show a confirmation message, if an upgrade through SSI.php was successful.
if(SMF == 'SSI')
   echo 'Database Upgrade Complete!';

?>